<template>
  <div id="series" class="serie-tab">
    <div class="trunk serie-tab-action">
      <client-only>
        <div class="serie-tabs">
          <div
            v-for="(item, index) of tabs"
            :key="`tab-${index}`"
            class="tab"
            :class="{ active: item === activeKey }"
            @click="setSelected(item)"
          >
            {{ getTabName(item) }}
          </div>
        </div>
        <template slot="placeholder">
          <a
            v-for="(item, index) of tabs"
            :key="`tab-${index}`"
            class="tab"
            :class="{ active: item === activeKey }"
            :href="defaultTabUrl(item)"
            >&nbsp;{{ getTabName(item) }}&nbsp;</a
          >
        </template>
      </client-only>

      <div class="serie-sort">
        <div class="only-mobile" @click="displayModal = true">
          <img
            class="sort-btn"
            :src="require('~/assets/images/bt-sort-default.svg')"
          />
        </div>

        <div class="sort only-desktop">
          <multiselect
            :value="currentFilter"
            :searchable="false"
            :allow-empty="false"
            label="label"
            track-by="value"
            :options="extendedFilters"
            :show-labels="false"
            @select="setFilter"
          ></multiselect>
        </div>

        <AppModal
          v-if="displayModal"
          :no-default="true"
          :closing-cross="true"
          :full-width="true"
          @close="displayModal = false"
        >
          <template v-slot:body>
            <div class="modal-filters">
              <div
                v-for="(item, index) of filters"
                :key="`filter-${index}`"
                :class="{
                  active: item.value === currentFilter.value,
                  default: item.value === 'default'
                }"
                @click="setFilter(item)"
              >
                {{ $t(item.label) }}
              </div>
            </div>
          </template>
        </AppModal>
      </div>
    </div>
    <SerieInfoBanner
      :serie="serie"
      :is-subscription="isSubscription"
      :connected="connected"
      :subscribed="subscribed"
    />
    <div v-for="(item, idx) in displayedList" :key="`album-${item.id}`">
      <SerieListItem
        :serie="serie"
        :album="item"
        :connected="connected"
        :subscribed="subscribed"
        :is-subscription="isSubscription"
      />
      <SerieInfoBanner
        v-if="displayWebtoonAboBanner(idx)"
        :serie="serie"
        :inline="true"
        :is-subscription="isSubscription"
        :connected="connected"
        :subscribed="subscribed"
      />
    </div>
    <client-only>
      <Pagination
        v-if="activeTabCount > paginationLimit"
        :current-page="currentPage"
        :total-page="activeTabTotalPage"
        :items-per-page="paginationLimit"
        @updatePage="updatePage"
      />
      <template slot="placeholder">
        <PaginationPlain
          v-if="activeTabCount > paginationLimit"
          :current-page="currentPage"
          :total-page="activeTabTotalPage"
          :items-per-page="paginationLimit"
          :base-url="baseUrlForPlainPagination"
        />
      </template>
    </client-only>
  </div>
</template>

<script>
import AppModal from '~/components/ui/AppModal'
import SerieListItem from '~/components/Serie/SerieListItem'
import Pagination from '~/components/ui/Pagination'
import PaginationPlain from '~/components/ui/PaginationPlain'
import SerieInfoBanner from '~/components/Serie/SerieInfoBanner'

export default {
  components: {
    AppModal,
    SerieListItem,
    Pagination,
    PaginationPlain,
    SerieInfoBanner
  },

  props: {
    serie: {
      type: Object,
      required: true
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    },
    subscribed: {
      type: Boolean,
      required: false,
      default: false
    },
    initialFilter: {
      type: String,
      required: false,
      default: undefined
    },
    initialTab: {
      type: String,
      required: false,
      default: undefined
    },
    initialPage: {
      type: Number,
      required: false,
      default: 1
    }
  },

  async fetch() {
    // load first page with albums for default tab
    if (this.initialTab) {
      this.activeKey = this.getAlbumTypeFromApiType(this.initialTab)
    } else {
      this.activeKey = this.defaultType
    }
    if (this.initialFilter) {
      this.currentFilter = this.initialFilterObj
    } else {
      this.currentFilter = this.defaultFilterForSerie
    }

    this.currentPage = +this.initialPage

    await this.loadAlbums(this.activeKey, this.currentPage)
  },

  data() {
    return {
      albums: {
        volume: { pages: [] },
        chapter: { pages: [] },
        other: { pages: [] },
        subscription: { pages: [] },
        paid: { pages: [] }
      },
      selected: [],
      displayedList: [],
      activeKey: '',
      displayModal: false,
      filters: [
        { label: this.$t('catalog.sort_new'), value: 'new' },
        { label: this.$t('catalog.sort_old'), value: 'old' },
        { label: this.$t('catalog.sort_price'), value: 'price' },
        { label: this.$t('catalog.sort_rate'), value: 'rate' }
      ],
      currentFilter: undefined,
      currentPage: 1,
      paginationLimit: 20
    }
  },

  computed: {
    initialFilterObj() {
      if (this.initialFilter) {
        const filter = this.filters.filter(
          (v) => v.value === this.initialFilter.toLowerCase()
        )
        if (filter.length) return filter[0]
      }
      return undefined
    },

    isSubscription() {
      return this.$utils.aboArea()
    },

    extendedFilters() {
      return [
        { label: this.$t('catalog.sort'), value: null, $isDisabled: true }
      ].concat(this.filters)
    },

    tabs() {
      const tabs = []

      if (this.connected && this.isSubscription) {
        if (this.serie.totalAlbumsInSubscription) {
          tabs.push('subscription')
        }
        if (this.serie.totalAlbumsNotInSubscription) {
          tabs.push('paid')
        }
      } else {
        if (this.serie.totalVolumes) {
          tabs.push('volume')
        }

        if (this.serie.totalChapters) {
          tabs.push('chapter')
        }

        if (this.serie.totalOthers) {
          tabs.push('other')
        }
      }
      return tabs
    },

    defaultType() {
      let type

      if (this.connected && this.isSubscription) {
        type = this.serie.totalAlbumsInSubscription ? 'subscription' : ''
        !type && (type = this.serie.totalAlbumsNotInSubscription ? 'paid' : '')
      } else {
        type = this.serie.totalVolumes ? 'volume' : ''
        !type && (type = this.serie.totalChapters ? 'chapter' : '')
        !type && (type = this.serie.totalOthers ? 'other' : '')
      }

      return type
    },

    activeTabCount() {
      return this.tabCount(this.activeKey)
    },

    activeTabTotalPage() {
      return Math.ceil(this.tabCount(this.activeKey) / this.paginationLimit)
    },

    allInCart() {
      return this.serie.serieBuyAll.allInCart
    },

    baseUrlForPlainPagination() {
      const baseUrl = this.baseUrlForAlbumType(this.activeKey)
      return `${baseUrl}/${this.currentFilter.value}`
    },

    defaultFilterForSerie() {
      if (this.serie.isWebtoon) return this.filters[1]
      else return this.filters[0]
    }
  },

  watch: {
    connected: function () {
      this.activeKey = this.defaultType
      this.resetTabs()
    },

    async allInCart() {
      this.resetAllPages()
      await this.loadAlbums(this.activeKey, this.currentPage)
    }
  },

  methods: {
    getTabName(type) {
      const trans = type === 'subscription' ? 'volume' : type
      const tabCount = this.tabCount(type)
      const tabName = this.$tc(`serie.${trans}`, tabCount)

      return `${tabCount} ${tabName}`
    },

    resetAllPages() {
      ;['volume', 'chapter', 'other', 'paid', 'subscription'].forEach(
        (type) => {
          this.albums[type].pages = []
        }
      )
    },

    async resetTabs() {
      this.resetAllPages()
      await this.loadAlbums(this.activeKey, 1)
      this.currentPage = 1
    },

    getAlbumTypeForApi(type) {
      const typeToParam = {
        volume: 'volumes',
        chapter: 'chapters',
        other: 'others',
        subscription: 'subscription',
        paid: 'to-buy'
      }
      return typeToParam[type]
    },

    getAlbumTypeFromApiType(apiType) {
      const typeToParam = {
        volumes: 'volume',
        chapters: 'chapter',
        others: 'other',
        subscription: 'subscription',
        paid: 'to-buy'
      }
      return typeToParam[apiType]
    },

    async loadAlbums(type, page) {
      if (!type) return

      if (!this.albums[type].pages[page - 1]) {
        let sort = this.currentFilter.value
        if ('rate' === sort) sort = 'rating'
        const albums = await this.$api.serieAlbums(
          this.serie.id,
          this.getAlbumTypeForApi(type),
          sort,
          (page - 1) * this.paginationLimit,
          this.paginationLimit
        )
        this.albums[type].pages[page - 1] = albums.albums
      }

      this.displayedList = this.albums[type].pages[page - 1]
    },

    albumIsFree(album) {
      return !album.price || album.price === '0.00'
    },

    albumHasPrice(album) {
      return album.price && album.price !== 'N/A'
    },

    setSelected(key) {
      this.activeKey = key
      this.loadAlbums(this.activeKey, 1)
      this.currentPage = 1
    },

    setFilter(filter) {
      this.currentFilter = filter
      this.displayModal = false
      this.resetTabs()
    },

    tabCount(key) {
      switch (key) {
        case 'volume':
          return this.serie.totalVolumes
        case 'chapter':
          return this.serie.totalChapters
        case 'other':
          return this.serie.totalOthers
        case 'subscription':
          return this.serie.totalAlbumsInSubscription
        case 'paid':
          return this.serie.totalAlbumsNotInSubscription
      }
    },

    async updatePage(currentPage) {
      await this.loadAlbums(this.activeKey, currentPage)
      this.currentPage = currentPage

      const top = document.getElementById('series').offsetTop
      window.scrollTo(0, top)
    },

    displayWebtoonAboBanner(index) {
      if (this.serie.isWebtoon && !this.subscribed) {
        if (this.currentPage === 1) {
          const freeAlbum =
            !this.displayedList[index].price ||
            this.displayedList[index].price === '0.00'
          const nextIndex = index + 1
          const nextAblumIsFree =
            this.displayedList[nextIndex] &&
            (!this.displayedList[nextIndex].price ||
              this.displayedList[nextIndex].price === '0.00')

          if (freeAlbum && !nextAblumIsFree) {
            return true
          }
        }
      }

      return false
    },

    baseUrlForAlbumType(type) {
      const serieUrl = this.localePath({
        // the 'abo-' route is not needed for SSR but makes this method universal
        name: `${this.isSubscription ? 'abo-' : ''}shelf-genre-slug`,
        params: {
          shelf: this.$route.params.shelf,
          genre: this.$route.params.genre,
          slug: this.$route.params.slug
        }
      })
      const typeForApi = this.getAlbumTypeForApi(type)
      return `${serieUrl}/${typeForApi}`
    },

    defaultTabUrl(type) {
      const baseUrlForAlbumType = this.baseUrlForAlbumType(type)
      const defaultFilter = this.defaultFilterForSerie.value
      return `${baseUrlForAlbumType}/${defaultFilter}/1`
    }
  }
}
</script>

<style lang="scss" scoped>
.serie-tab-action {
  display: flex;
  justify-content: space-around;
  padding: 1rem;

  @media (max-width: 768px) {
    border-bottom: solid 1px #d8d8d8;
  }

  .serie-tabs {
    flex: 1;
    display: flex;
    align-content: flex-start;

    .tab {
      cursor: pointer;
      margin-right: 2rem;
      padding: 0.5rem;
      padding-bottom: 0.75rem;

      &:hover,
      &.active {
        border-bottom: 5px solid #ff641e;
      }

      @media (max-width: 768px) {
        margin-right: 0.75rem;
        font-size: 14px;
        padding: 0.25rem;
        padding-bottom: 0.5rem;
      }
    }
  }

  .serie-sort {
    flex: 1;
    text-align: right;

    .sort-btn {
      min-width: 32px;
      min-height: 32px;
    }
    @media (max-width: 768px) {
      flex: inherit;
    }
  }

  .sort-select {
    background: white;
  }

  .modal-filters {
    div {
      cursor: pointer;
      margin: 1.5rem 0;
    }

    .active {
      font-weight: bold;
    }

    .default {
      color: #808080;
    }
  }

  .only-mobile {
    display: none;
  }

  .only-desktop {
    display: inline-block;
  }

  @media (max-width: 768px) {
    .only-mobile {
      display: block;

      &.sort-btn {
        display: inline-block;
      }
    }

    .only-desktop {
      display: none;
    }
  }
}
</style>

<style lang="scss">
.serie-sort {
  .multiselect {
    &__content-wrapper {
      border: none;
      box-shadow: 0 0 8px 0 rgba(0, 0, 0, 0.25);
    }

    &__tags {
      border: 0;
      min-width: 200px;
    }

    &__option--disabled {
      color: #999 !important;
      background: #fff !important;
    }

    &__option--selected {
      background: #fff !important;
    }

    &__option--highlight {
      background-color: #5897fb !important;
    }
  }
}
</style>
